local nom = "Nom Nom Nom"
local notnoml,_ = GetSpellInfo(80863)
local blacklist={"Blood in the Water","Blut im Wasser","Sangre en el agua","Du sang dans l'eau","Blitz"}

local nomfunc = function(tooltip,...)
	local title = _G[tooltip:GetName() .. 'TextLeft1']
	if title then 
		title:SetText(gsub(title:GetText(),notnoml,"Nom Nom Nom"))
		end	
	end

GameTooltip:HookScript("OnTooltipSetSpell", nomfunc)
ItemRefTooltip:HookScript("OnTooltipSetSpell", nomfunc)
-- other, addon-specific tooltip hooks may be put here

local incoming = function(self, event, msg, ...)
	for _,notnom in pairs(blacklist) do
		msg = gsub(msg,"\124Hspell%:(%d+)\124h%["..notnom.."%]\124h","|Hspell:%1|h["..nom.."]|h")
		msg = gsub(msg,"\124Htalent%:(%d+%:%-?%d)\124h%["..notnom.."%]\124h","|Htalent:%1|h["..nom.."]|h")
	end 
	return false, msg, ...
end
local outgoing = function(msg, ...)
	msg = gsub(msg,"\124h%["..nom.."%]\124h","|h["..notnoml.."]|h")
	return hSCM(msg,...)
end
local linkfunc = function(text)
 -- this is more of a backup should you still encounter any link with "notnom" text and then try to link that spell in chat. This includes the "link" function from Wowhead or other DB sites. We can't hook that anyway, not that I wanted to meddle with other addons'/sources' stuff.
	if(text) then
	for _,notnom in pairs(blacklist) do
		text = gsub(text,"\124Hspell%:(%d+)\124h%["..notnom.."%]\124h","|Hspell:%1|h["..nom.."]|h")
		text = gsub(text,"\124Htalent%:(%d+%:%-?%d)\124h%["..notnom.."%]\124h","|Htalent:%1|h["..nom.."]|h")
	end end
	return hIL(text)
end

--events={}
events={"CHAT_MSG_AFK","CHAT_MSG_BATTLEGROUND","CHAT_MSG_BATTLEGROUND_LEADER","CHAT_MSG_BN_CONVERSATION","CHAT_MSG_BN_WHISPER","CHAT_MSG_BN_WHISPER_INFORM","CHAT_MSG_CHANNEL","CHAT_MSG_DND","CHAT_MSG_EMOTE","CHAT_MSG_GUILD","CHAT_MSG_IGNORED","CHAT_MSG_OFFICER","CHAT_MSG_PARTY","CHAT_MSG_PARTY_LEADER","CHAT_MSG_RAID","CHAT_MSG_RAID_LEADER","CHAT_MSG_RAID_WARNING","CHAT_MSG_SAY","CHAT_MSG_WHISPER","CHAT_MSG_WHISPER_INFORM","CHAT_MSG_YELL"}
for i,e in pairs(events) do
	ChatFrame_AddMessageEventFilter(e, incoming) end

--hooks, very dirty
hSCM=SendChatMessage
SendChatMessage=outgoing
hIL=ChatEdit_InsertLink
ChatEdit_InsertLink=linkfunc


local bframe = CreateFrame('Frame');
local t = 0.1
bframe:SetScript("OnUpdate", function(frame, elapsed) 
t = t-elapsed
if frame:IsShown() and t<0 then
	t = 0.1
	for i=1,WorldFrame:GetNumChildren() do
		local c = select(i, WorldFrame:GetChildren())
		local b = c:GetBackdrop()
		if b and b.bgFile == "Interface\\Tooltips\\ChatBubble-Background" then
			for i=1,c:GetNumRegions() do
				local r = select(i, c:GetRegions())
				if r:GetObjectType() == "FontString" then
					r:SetText(gsub(r:GetText(),"Blood in the Water","Nom Nom Nom"))
					break -- should be the last region anyway, but break nevertheless
				end
			end
		end
	end
end
end)